#include <FK/FK.h>

// Ɏw肳ꂽfk_Model̕ϐA摜\x[X̍WnƂď
void makePixelBase(fk_Model *argModel, fk_Window *argWin, fk_Scene *argScn)
{
	fk_Perspective	*pers = NULL;
	fk_Ortho		*orth = NULL;
	double	winH = (double)argWin->h();
	double	halfFovy, putNear;

	if(argScn->getProjection()->getMode() == FK_PERSPECTIVE_MODE) {
		pers = (fk_Perspective *)argScn->getProjection();
		halfFovy = pers->getFovy()*0.5;
		putNear = pers->getNear()+1.0;
	} else {
		return;
	}

	argModel->setParent((fk_Model*)argScn->getCamera());
	argModel->glMoveTo(0.0, 0.0, -putNear);
	argModel->setScale((putNear*tan(halfFovy)*2.0/winH), (putNear*tan(halfFovy)*2.0/winH), 1.0);

	return;
}

int main(int argc, char *argv[])
{
	Fl_Window		mainWindow(1024, 768, "FK TEST");
	fk_Model		camera, blockModel, lightModel;
	fk_Light		light;
	fk_Block		block(50.0, 70.0, 40.0);
	fk_Scene		scene;
	fk_Window		window(0, 0, 1024, 768);

	fk_Image		img, filterImg, numImg;
	fk_TextImage	text;
	fk_UniStr		str;
	fk_RectTexture	tex, textTex, filterTex, numTex[3];
	fk_Model		texModel, textModel, filterModel, numModel[3];

	fk_Material		pixelMate;
	fk_Model		pixelBase;

	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// ̂̐ݒ
	blockModel.setShape(&block);
	blockModel.setMaterial(Yellow);

	// 摜ʂŎg}eA
	pixelMate.setEmission(1.0, 1.0, 1.0);
	pixelMate.setAlpha(1.0);

	// wi摜̏
	img.readJPG("wp.jpg");
	tex.setImage(&img);
	tex.setTextureMode(FK_TEX_MODULATE);
	tex.setTexRendMode(FK_TEX_REND_SMOOTH);
	texModel.setShape(&tex);
	texModel.setMaterial(pixelMate);

	// eLXg摜̏
	if(text.initFont("VL-PGothic-Regular.ttf") == false) fl_alert("initFont() error!");
	text.setDPI(96);	// 96ŌŒ肪
	text.setPTSize(36);	// DPI96ŌŒ肵AWordƂŎw肷̂Ɠ|CgOK
	text.setForeColor(0.5, 1.0, 0.8, 1.0);
	text.setBackColor(0.2, 0.2, 0.2, 0.6);
	text.setAlign(FK_ALIGN_CENTER);
	text.setSendingMode(FK_SENDING_CHAR);	// 胂[h̐ݒ
	textTex.setImage(&text);
	textTex.setTextureMode(FK_TEX_MODULATE);
	textTex.setTexRendMode(FK_TEX_REND_SMOOTH);
	textModel.setShape(&textTex);
	textModel.setMaterial(pixelMate);

	// 摜ɏo(ɍXVꍇ͂̈A̗JԂ΂悢)
	str.clear();
	str.convert("mxQ[\ł\n", FK_STR_SJIS);
	str.convert("ĕnƂЂƂ܂Ƃ܂ɂȂ", FK_STR_SJIS);
	text.loadUniStr(&str);

	// tF[htB^摜̏
	filterImg.newImage(8, 8);
	filterImg.fillColor(255, 255, 255, 255);
	filterTex.setImage(&filterImg);
	filterTex.setTextureMode(FK_TEX_MODULATE);
	filterTex.setTexRendMode(FK_TEX_REND_SMOOTH);
	filterModel.setShape(&filterTex);
	filterModel.setMaterial(pixelMate);

	filterModel.getMaterial()->setAlpha(0.0);	// SɂĂ

	// Lg摜
	numImg.readPNG("pop_font.png");
	for(int i = 0; i < 3; i++) {
		numTex[i].setImage(&numImg);
		numTex[i].setTextureMode(FK_TEX_MODULATE);
		numTex[i].setTexRendMode(FK_TEX_REND_SMOOTH);
		numModel[i].setShape(&numTex[i]);
		numModel[i].setMaterial(pixelMate);
	}
	// Lg
	numTex[0].setTextureCoord(       0.0, 1.0-40.0/128.0, 30.0/512.0, 1.0);
	numTex[1].setTextureCoord(30.0/512.0, 1.0-40.0/128.0, 60.0/512.0, 1.0);
	numTex[2].setTextureCoord(60.0/512.0, 1.0-40.0/128.0, 90.0/512.0, 1.0);


	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.3f, 0.3f, 0.8f);
	scene.entryCamera(&camera);
	scene.entryModel(&blockModel);
	scene.entryModel(&lightModel);

	// V[ɃJZbgԂŁAx[Xf̏Ԃ쐬
	makePixelBase(&pixelBase, &window, &scene);

	// wĩTCYw肵ĕ\
	texModel.setParent(&pixelBase);
	tex.setTextureSize((double)img.getWidth(), (double)img.getHeight());
	scene.entryOverlayModel(&texModel);

	// eLXg̃TCYw肵ĕ\
	textModel.setParent(&pixelBase);
	textTex.setTextureSize((double)text.getWidth(), (double)text.getHeight());
	scene.entryOverlayModel(&textModel);

	// tB^̃TCYIɃEBhETCYɂA\͂܂Ȃ
	filterModel.setParent(&pixelBase);
	filterTex.setTextureSize(1024.0, 768.0);

	// Lg摜̃TCYƈʒuw肵ĕ\
	for(int i = 0; i < 3; i++) {
		numModel[i].setParent(&pixelBase);
		numModel[i].glMoveTo(-256.0+i*32.0, 80.0, 0.0);
		numTex[i].setTextureSize(32.0, 40.0);
		scene.entryOverlayModel(&numModel[i]);
	}


	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 0.0, 1000.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	mainWindow.show();
	window.show();

	// NbNuԂm̂ɂ悭
	bool prevClick = window.getMouseStatus(FK_MOUSE1, false);

	while(true) {

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(window.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		lightModel.loFocus(0.001, 0.0, 0.0);

		// sNZPʂ̈ړ
		if(window.getSpecialKeyStatus(FK_UP, false)) {
			textModel.glTranslate(0.0, -1.0, 0.0);
		}
		if(window.getSpecialKeyStatus(FK_DOWN, false)) {
			textModel.glTranslate(0.0, 1.0, 0.0);
		}
		if(window.getSpecialKeyStatus(FK_LEFT, false)) {
			textModel.glTranslate(-1.0, 0.0, 0.0);
		}
		if(window.getSpecialKeyStatus(FK_RIGHT, false)) {
			textModel.glTranslate(1.0, 0.0, 0.0);
		}

		// 
		if(window.getMouseStatus(FK_MOUSE1, false) & !prevClick) {
			text.send();
		}
		prevClick = window.getMouseStatus(FK_MOUSE1, false);

		// zCgAEg
		if(window.getMouseStatus(FK_MOUSE3, false)) {
			fk_Material	*tmpMate = filterModel.getMaterial();
			tmpMate->setAlpha(tmpMate->getAlpha()+(1.0/60.0));
			scene.entryOverlayModel(&filterModel);
		}
		// zCgC
		if(window.getMouseStatus(FK_MOUSE1, false)) {
			fk_Material	*tmpMate = filterModel.getMaterial();
			tmpMate->setAlpha(tmpMate->getAlpha()-(1.0/60.0));
			scene.entryOverlayModel(&filterModel);
		}

		// ̕\etB^ƂĐݒAߗ
		// wi摜ĔwiFƃfČ悤ɂȂ
		if(window.getMouseStatus(FK_MOUSE2, false)) {
			window.snapImage(&filterImg);
			filterModel.getMaterial()->setAlpha(1.0);
			scene.removeOverlayModel(&texModel);
			scene.entryOverlayModel(&filterModel);
		}

		// tF[hCEAEg
		if(window.getSpecialKeyStatus(FK_PAGE_DOWN, false)) {
			fk_Material	*tmpMate = textModel.getMaterial();
			tmpMate->setAlpha(tmpMate->getAlpha()-(1.0/60.0));
		}
		if(window.getSpecialKeyStatus(FK_PAGE_UP, false)) {
			fk_Material	*tmpMate = textModel.getMaterial();
			tmpMate->setAlpha(tmpMate->getAlpha()+(1.0/60.0));
		}

	}

	return 0;
}
